<div class="container-fluid p-py-5 role-assignment-override">
  <div class="row justify-content-center">
    <div class="col-5">
      <ng-container *ngIf="mode === 'UserRole'; else roleUserLeft">
        <p-listbox
          [options]="leftItems"
          optionLabel="label"
          optionValue="value"
          [(ngModel)]="selectedLeftItem"
          (onChange)="onLeftItemChange()"
          [filter]="true"
          [style]="{ width: '100%' }"
          [listStyle]="{ height: '548px' }"
        >
          <p-header>
            <i class="fa fa-users"></i>
            Users
          </p-header>
        </p-listbox>
      </ng-container>
      <ng-template #roleUserLeft>
        <p-listbox
          [options]="leftItems"
          optionDisabled="false"
          optionLabel="label"
          optionValue="value"
          (onClick)="onRowSelectRole($event.option.value)"
          [filter]="true"
          [style]="{ width: '100%' }"
          [listStyle]="{ height: '548px' }"
        >
          <p-header>
            <div>
              <i class="fa fa-tags"></i>
              Roles
            </div>
          </p-header>

          <ng-template *ngIf="hasWritePermission" pTemplate="item" let-role>
            <div class="col d-flex">
              <div class="flex-grow-1">
                <span>
                  {{ role.label }}
                </span>
                <button
                  pButton
                  icon="fa fa-pencil"
                  class="float-right p-button-success"
                  (click)="onEditRole(role.value)"
                ></button>
              </div>
            </div>
          </ng-template>
          <p-footer *ngIf="hasWritePermission">
            <div class="col d-flex">
              <div class="flex-grow-1 rowStyle">Name</div>
              <button
                pButton
                icon="fa fa-plus"
                (click)="onAddRole()"
                [disabled]="!hasWritePermission"
              ></button>
            </div>
          </p-footer>
        </p-listbox>
      </ng-template>
    </div>
    <div class="changeMode">
      <button pButton icon="fa fa-exchange" (click)="changeMode()"></button>
    </div>
    <div class="col-5">
      <ng-container *ngIf="mode === 'UserRole'; else roleUserRight">
        <p-listbox
          optionDisabled="false"
          [options]="rightItems"
          [style]="{ width: '100%' }"
          [listStyle]="{ height: '596px' }"
        >
          <p-header>
            <div>
              <i class="fa fa-tags"></i>
              Role
            </div>
          </p-header>
          <ng-template
            *ngIf="hasWritePermission"
            pTemplate="item"
            pTemplate="item"
            let-role
          >
            <div class="col d-flex">
              <div class="flex-grow-1">
                <ng-container *ngIf="isEditMode; else nonEditMode">

                  <app-filter-dropdown
                    appendTo="body"
                    [options]="roleDropdownItems"
                    [(selectedItem)]="selectedRoleDropdownItem"
                    [style]="{ width: 'calc(100% - 8em)' }"
                  ></app-filter-dropdown>

                  <button
                    pButton
                    icon="fa fa-check"
                    class="mb-3 float-right p-button-success"
                    (click)="editUserRole(role.value, false)"
                  ></button>

                  <button
                    pButton
                    icon="fa fa-ban"
                    class="mb-3 float-right p-button-warning mx-2"
                    (click)="cancelEditUserRole()"
                  ></button>
                </ng-container>
                <ng-template #nonEditMode>
                  <div class="col d-flex justify-content-between">
                    <div>
                      {{ role.label }}
                    </div>
                    <button
                      pButton
                      icon="fa fa-pencil"
                      class="p-button-warning"
                      (click)="changeEditMode(null)"
                    ></button>
                  </div>
                </ng-template>
              </div>
            </div>
          </ng-template>
        </p-listbox>
      </ng-container>
      <ng-template #roleUserRight>
        <p-listbox
          [options]="rightItems"
          optionDisabled="false"
          optionLabel="label"
          optionValue="value"
          [filter]="true"
          [style]="{ width: '100%' }"
          [listStyle]="{ height: '548px' }"
        >
          <p-header>
            <div>
              <i class="fa fa-users"></i>
              Users
            </div>
          </p-header>
          <ng-template *ngIf="hasWritePermission" pTemplate="item" let-user>
            <div class="col d-flex">
              <div class="flex-grow-1">
                <span>
                  {{ user.label }}
                </span>

                <ng-container
                  *ngIf="
                    isEditMode && user.value.id === selectedRightItem.id;
                    else nonEditMode
                  "
                >
                  <button
                    pButton
                    icon="fa fa-check"
                    class="mb-3 float-right p-button-success"
                    (click)="editUserRole(user.value, false)"
                  ></button>

                  <button
                    pButton
                    icon="fa fa-ban"
                    class="mb-3 float-right p-button-warning mx-2"
                    (click)="cancelEditUserRole()"
                  ></button>

                  <app-filter-dropdown
                    appendTo="body"
                    [options]="roleDropdownItems"
                    [(selectedItem)]="selectedRoleDropdownItem"
                    [style]="{ width: '100%' }"
                  ></app-filter-dropdown>
                </ng-container>

                <ng-template #nonEditMode>
                  <button
                    pButton
                    icon="fa fa-pencil"
                    class="float-right p-button-warning"
                    (click)="changeEditMode(user.value)"
                  ></button>
                </ng-template>
              </div>
            </div>
          </ng-template>
          <p-footer>
            <div class="col d-flex">
              <div class="flex-grow-1">
                <app-filter-dropdown
                  [options]="userDropdownItems"
                  [(selectedItem)]="selectedUserDropdownItem"
                  [style]="{ width: 'calc(100% - 0.857em)' }"
                ></app-filter-dropdown>
              </div>
              <button
                pButton
                icon="fa fa-plus"
                (click)="editUserRole(selectedUserDropdownItem, true)"
                [disabled]="!selectedUserDropdownItem"
              ></button>
            </div>
          </p-footer>
        </p-listbox>
      </ng-template>
    </div>
  </div>

  <p-dialog
    [(visible)]="editDialogVisible"
    [responsive]="true"
    [resizable]="false"
    showEffect="fade"
    [modal]="true"
    [style]="{ width: '530px' }"
    (onHide)="onHideEditModal()"
  >
    <div class="form-group form-row" style="margin-top: 1rem">
      <div class="col-2 col-form-label align-self-center">Name</div>
      <div class="col-10">
        <input
          pInputText
          #roleNameInput="ngModel"
          [(ngModel)]="editRole.name"
          type="text"
          class="w-100"
          [maxLength]="RoleNameMaxLength"
          noWhiteSpaces
        />
        <div *ngIf="roleNameInput.touched && roleNameInput.control.invalid" class="form-text text-danger">
          <div *ngIf="roleNameInput.control.errors.maxLength">Role name cannot be longer than {{ RoleNameMaxLength }} characters</div>
          <div *ngIf="roleNameInput.control.errors.canNotContainWhiteSpaces">Role name can not contain whitespaces</div>
        </div>
      </div>
    </div>

    <div class="form-group">
      <p-table
        [value]="editRole.rolePermission"
        [scrollable]="true"
        scrollHeight="370px"
        styleClass="p-datatable-striped"
      >
        <ng-template pTemplate="header">
          <tr>
            <th>Name</th>
            <th>Read</th>
            <th>Write</th>
          </tr>
        </ng-template>
        <ng-template pTemplate="body" let-rolePermission>
          <tr [ngClass]="{ protected: rolePermission.permission.isProtected }">
            <td>{{ rolePermission.permission.name }}</td>
            <td>
              <p-checkbox
                [(ngModel)]="rolePermission.read"
                [binary]="true"
                [disabled]="rolePermission.permission.isProtected"
              ></p-checkbox>
            </td>
            <td>
              <p-checkbox
                [(ngModel)]="rolePermission.write"
                [binary]="true"
                [disabled]="rolePermission.permission.isProtected"
              ></p-checkbox>
            </td>
          </tr>
        </ng-template>
      </p-table>
    </div>

    <div class="d-flex justify-content-between">
      <span *ngIf="editRole.id"
        [pTooltip]="editRole.isSystemRole
          ? 'You cannot delete system-defined role'
          : null"
        tooltipPosition="right"
      >
        <button pButton
          id="btnDeleteRole"
          class="p-button-danger"
          [disabled]="editRole.isSystemRole || confirmModalVisible"
          (click)="onDeleteRole()"
        >
          <span class="p-button-label">Delete</span>
          <span *ngIf="!editRole.isSystemRole && editRole.isAssignedToUser"
            class="d-inline-block button-info-tooltip pl-2"
            tooltipStyleClass="tooltip-icon-button"
            pTooltip="This role is assigned to at least one user"
          >
            <i class="icon- fa fa-exclamation-circle"></i>
          </span>
        </button>
      </span>
      <button pButton class="ml-auto px-4" label="Save" (click)="onSaveRole()"
        [disabled]="confirmModalVisible || roleNameInput.control.invalid"
      ></button>
    </div>
  </p-dialog>

  <p-dialog *ngIf="deleteRoleModel" header="Delete role"
    [(visible)]="deleteDialogVisible"
    [resizable]="false"
    showEffect="fade"
    [modal]="true"
    class="delete-modal"
    (onHide)="closeConfirmModal()"
  >
    <p class="warning m-2">
      <strong>Warning:</strong> This role is assigned to at least one user. You need to select new role for users in order to proceed.
    </p>
    <p class="pl-2 pt-2">You are deleting role <strong>{{ deleteRoleModel.name }}</strong></p>
    <div class="d-flex my-2">
      <div class="col-4">
        <label class="pt-1" for="reassingRoleDropdown">Reassign users to role:</label>
      </div>
      <div class="col-8">
        <app-filter-dropdown
          id="fallbackRoleDropdown"
          appendTo="body"
          placeholder="Please select a role"
          [options]="fallbackRoleDropdownItems"
          [(selectedItem)]="selectedFallbackRoleDropdownItem"
        ></app-filter-dropdown>
      </div>
    </div>
    <div class="d-flex justify-content-end p-2">
      <button pButton id="btnDeleteRoleCancel" class="p-button-outlined mx-2" label="Cancel"
        (click)="hideAllDialog()"
      ></button>
      <button pButton id="btnApplyAndDeleteRole" class="p-button-danger" label="Apply and Delete"
        [disabled]="confirmModalVisible || !selectedFallbackRoleDropdownItem"
        (click)="confirmDeleteRole()"
      ></button>
    </div>
  </p-dialog>
</div>
